//============================================================================
//
//This confidential and proprietary software may be used only as authorized
//by a licensing agreement from Texas Instruments, US.
//
//     In the event of publication, the following notice is applicable:
//
//                        (C) COPYRIGHT 2007 TI
//                          ALL RIGHTS RESERVED
//
// Entire notice above must be reproduced on all authorized copies.
//
//
// Title:      %M%
// Version:    %I%
// Date:       %G%
// Author:     Hamza Fraz
// Modified:   RMP added capture modes register, bit/byte mode for DDR capture
//============================================================================


`ifdef SIMULATE_IN_MODELSIM
`else
	`include "defines.vh"
`endif
module ads5463_toplevel(
			DDRClk_p_pin,
			DDRClk_n_pin,
			SysClk_p_pin,
			SysClk_n_pin,
			SysRst_pin,
			ChanEn_pin,

			AppUART_Sin_pin,
			AppUART_RTSn_pin,
			AppUART_DTRn_pin,
			AppUART_Sout_pin,
			AppUART_CTSn_pin,
			AppUART_DSRn_pin,
			AppUART_DCDn_pin,
			AppUART_RIn_pin,

			AppSPI_Ss_pin,
			AppSPI_Mosi_pin,
			AppSPI_Sclk_pin,
			CLKOUT_pin,

			D0_n_pin,
			D0_p_pin,
			D1_n_pin,
			D1_p_pin,
			D2_n_pin,
			D2_p_pin,
			D3_n_pin,
			D3_p_pin,
			D4_n_pin,
			D4_p_pin,
			D5_n_pin,
			D5_p_pin,
			D6_n_pin,
			D6_p_pin,
			D7_n_pin,
			D7_p_pin,
			D8_n_pin,
			D8_p_pin,
			D9_n_pin,
			D9_p_pin,
			D10_n_pin,
			D10_p_pin,
			D11_n_pin,
			D11_p_pin,
			D12_n_pin,
			D12_p_pin,
			D13_n_pin,
			D13_p_pin,
			D14_n_pin,
			D14_p_pin,

			D20_n_pin,
			D20_p_pin,
			D21_n_pin,
			D21_p_pin,
			D22_n_pin,
			D22_p_pin,
			D23_n_pin,
			D23_p_pin,
			D24_n_pin,
			D24_p_pin,
			D25_n_pin,
			D25_p_pin,
			D26_n_pin,
			D26_p_pin,
			D27_n_pin,
			D27_p_pin,
			D28_n_pin,
			D28_p_pin,
			D29_n_pin,
			D29_p_pin,
			D30_n_pin,
			D30_p_pin,
			D31_n_pin,
			D31_p_pin,
			D32_n_pin,
			D32_p_pin,
			D33_n_pin,
			D33_p_pin,
			D34_n_pin,
			D34_p_pin,

			AppDatClkCh1_pin,
			AppDatClkCh2_pin,
			AppDatClkCh3_pin,
			AppDatClkCh4_pin,
			AppTP0_pin,
			AppTP1_pin,
			AppTP2_pin,
			AppTP3_pin,
			AppLed_pin
			);

input			DDRClk_p_pin;
input			DDRClk_n_pin;
input			SysClk_p_pin;
input			SysClk_n_pin;
input			SysRst_pin;
input			ChanEn_pin;
input			CLKOUT_pin;

input			D0_n_pin;
input			D0_p_pin;
input			D1_n_pin;
input			D1_p_pin;
input			D2_n_pin;
input			D2_p_pin;
input			D3_n_pin;
input			D3_p_pin;
input			D4_n_pin;
input			D4_p_pin;
input			D5_n_pin;
input			D5_p_pin;
input			D6_n_pin;
input			D6_p_pin;
input			D7_n_pin;
input			D7_p_pin;
input			D8_n_pin;
input			D8_p_pin;
input			D9_n_pin;
input			D9_p_pin;
input			D10_n_pin;
input			D10_p_pin;
input			D11_n_pin;
input			D11_p_pin;
input			D12_n_pin;
input			D12_p_pin;
input			D13_n_pin;
input			D13_p_pin;
input			D14_n_pin;
input			D14_p_pin;

input			D20_n_pin;
input			D20_p_pin;
input			D21_n_pin;
input			D21_p_pin;
input			D22_n_pin;
input			D22_p_pin;
input			D23_n_pin;
input			D23_p_pin;
input			D24_n_pin;
input			D24_p_pin;
input			D25_n_pin;
input			D25_p_pin;
input			D26_n_pin;
input			D26_p_pin;
input			D27_n_pin;
input			D27_p_pin;
input			D28_n_pin;
input			D28_p_pin;
input			D29_n_pin;
input			D29_p_pin;
input			D30_n_pin;
input			D30_p_pin;
input			D31_n_pin;
input			D31_p_pin;
input			D32_n_pin;
input			D32_p_pin;
input			D33_n_pin;
input			D33_p_pin;
input			D34_n_pin;
input			D34_p_pin;


input			AppUART_Sin_pin;
input			AppUART_RTSn_pin;
input			AppUART_DTRn_pin;

output			AppUART_Sout_pin;
output			AppUART_CTSn_pin;
output			AppUART_DSRn_pin;
output			AppUART_DCDn_pin;
output			AppUART_RIn_pin;
output [3:0]	AppLed_pin;
output			AppSPI_Ss_pin;
output			AppSPI_Mosi_pin;
output			AppSPI_Sclk_pin;
//begin uncomment JRV
output			AppDatClkCh1_pin;
output			AppDatClkCh2_pin;
output			AppDatClkCh3_pin;
output			AppDatClkCh4_pin;
output	[13:0]	AppTP0_pin;
output	[15:0]	AppTP1_pin;
output	[15:0]	AppTP2_pin;
output	[13:0]	AppTP3_pin;
//end uncomment JRV
//-----------------------------------------------------------------------------

wire			IntSysClk;
wire			IntSysClkDiv;
wire			IntSysRst;
wire			SysRst;
wire			IntChanEn;
wire			ChanEn;

wire			IntDx00;
wire			IntDx01;
wire			IntDx02;
wire			IntDx03;
wire			IntDx04;
wire			IntDx05;
wire			IntDx06;
wire			IntDx07;
wire			IntDx08;
wire			IntDx09;
wire			IntDx10;
wire			IntDx11;
wire			IntDx12;
wire			IntDx13;
wire			IntDx14;

wire			IntDx20;
wire			IntDx21;
wire			IntDx22;
wire			IntDx23;
wire			IntDx24;
wire			IntDx25;
wire			IntDx26;
wire			IntDx27;
wire			IntDx28;
wire			IntDx29;
wire			IntDx30;
wire			IntDx31;
wire			IntDx32;
wire			IntDx33;
wire			IntDx34;


wire			C;

wire	[`data_width-1:0]	IntDx;
wire	[`data_width-1:0]	IntDx2;
wire	[15:0]	dlydbit_sel;
wire	[7:0]		cap_modes;
wire	[7:0]		chan_sel;
wire	[5:0]	dlyinc_val;

wire			IntAppUART_Sin;
wire			IntAppUART_RTSn;
wire			IntAppUART_DTRn;
wire			IntAppUART_Sout;
wire			IntAppUART_CTSn;
wire			IntAppUART_DSRn;
wire			IntAppUART_DCDn;
wire			IntAppUART_RIn;
wire			IntAppSPI_Ss;
wire			IntAppSPI_Mosi;
wire			IntAppSPI_Sclk;
wire			tusb_bclk;
wire			usb_busy;
wire			usb_busy_b;
wire			SysLife;
wire			AdcLife;
wire			ch1_clk;
wire			ch2_clk;
wire			ch3_clk;
wire			ch4_clk;

reg				rts_n;
reg				dtr_n;
wire	[15:0]	pIntDx_r;
wire	[15:0]	nIntDx_r;
wire	[15:0]	pIntDx90_r;
wire	[15:0]	nIntDx90_r;
reg			IntChanEn1;
reg			IntChanEn2;
reg			IntChanEn3;
reg			IntChanEn4;

//-----------------------------------------------------------------------------

IBUFDS #(.DIFF_TERM("TRUE"),.IOSTANDARD("LVDS_25")) 	IBUFDS_inst00(.I(D0_p_pin) , .IB(D0_n_pin) , .O(IntDx00));
IBUFDS #(.DIFF_TERM("TRUE"),.IOSTANDARD("LVDS_25")) 	IBUFDS_inst01(.I(D1_p_pin) , .IB(D1_n_pin) , .O(IntDx01));
IBUFDS #(.DIFF_TERM("TRUE"),.IOSTANDARD("LVDS_25")) 	IBUFDS_inst02(.I(D2_p_pin) , .IB(D2_n_pin) , .O(IntDx02));
IBUFDS #(.DIFF_TERM("TRUE"),.IOSTANDARD("LVDS_25")) 	IBUFDS_inst03(.I(D3_p_pin) , .IB(D3_n_pin) , .O(IntDx03));
IBUFDS #(.DIFF_TERM("TRUE"),.IOSTANDARD("LVDS_25")) 	IBUFDS_inst04(.I(D4_p_pin) , .IB(D4_n_pin) , .O(IntDx04));
IBUFDS #(.DIFF_TERM("TRUE"),.IOSTANDARD("LVDS_25")) 	IBUFDS_inst05(.I(D5_p_pin) , .IB(D5_n_pin) , .O(IntDx05));
IBUFDS #(.DIFF_TERM("TRUE"),.IOSTANDARD("LVDS_25")) 	IBUFDS_inst06(.I(D6_p_pin) , .IB(D6_n_pin) , .O(IntDx06));
IBUFDS #(.DIFF_TERM("TRUE"),.IOSTANDARD("LVDS_25")) 	IBUFDS_inst07(.I(D7_p_pin) , .IB(D7_n_pin) , .O(IntDx07));
IBUFDS #(.DIFF_TERM("TRUE"),.IOSTANDARD("LVDS_25")) 	IBUFDS_inst08(.I(D8_p_pin) , .IB(D8_n_pin) , .O(IntDx08));
IBUFDS #(.DIFF_TERM("TRUE"),.IOSTANDARD("LVDS_25")) 	IBUFDS_inst09(.I(D9_p_pin) , .IB(D9_n_pin) , .O(IntDx09));
IBUFDS #(.DIFF_TERM("TRUE"),.IOSTANDARD("LVDS_25")) 	IBUFDS_inst10(.I(D10_p_pin), .IB(D10_n_pin), .O(IntDx10));
IBUFDS #(.DIFF_TERM("TRUE"),.IOSTANDARD("LVDS_25")) 	IBUFDS_inst11(.I(D11_p_pin), .IB(D11_n_pin), .O(IntDx11));
IBUFDS #(.DIFF_TERM("TRUE"),.IOSTANDARD("LVDS_25")) 	IBUFDS_inst12(.I(D12_p_pin), .IB(D12_n_pin), .O(IntDx12));
IBUFDS #(.DIFF_TERM("TRUE"),.IOSTANDARD("LVDS_25")) 	IBUFDS_inst13(.I(D13_p_pin), .IB(D13_n_pin), .O(IntDx13));
IBUFDS #(.DIFF_TERM("TRUE"),.IOSTANDARD("LVDS_25")) 	IBUFDS_inst14(.I(D14_p_pin), .IB(D14_n_pin), .O(IntDx14));

IBUFDS #(.DIFF_TERM("TRUE"),.IOSTANDARD("LVDS_25")) 	IBUFDS_inst20(.I(D20_p_pin) , .IB(D20_n_pin) , .O(IntDx20));
IBUFDS #(.DIFF_TERM("TRUE"),.IOSTANDARD("LVDS_25")) 	IBUFDS_inst21(.I(D21_p_pin) , .IB(D21_n_pin) , .O(IntDx21));
IBUFDS #(.DIFF_TERM("TRUE"),.IOSTANDARD("LVDS_25")) 	IBUFDS_inst22(.I(D22_p_pin) , .IB(D22_n_pin) , .O(IntDx22));
IBUFDS #(.DIFF_TERM("TRUE"),.IOSTANDARD("LVDS_25")) 	IBUFDS_inst23(.I(D23_p_pin) , .IB(D23_n_pin) , .O(IntDx23));
IBUFDS #(.DIFF_TERM("TRUE"),.IOSTANDARD("LVDS_25")) 	IBUFDS_inst24(.I(D24_p_pin) , .IB(D24_n_pin) , .O(IntDx24));
IBUFDS #(.DIFF_TERM("TRUE"),.IOSTANDARD("LVDS_25")) 	IBUFDS_inst25(.I(D25_p_pin) , .IB(D25_n_pin) , .O(IntDx25));
IBUFDS #(.DIFF_TERM("TRUE"),.IOSTANDARD("LVDS_25")) 	IBUFDS_inst26(.I(D26_p_pin) , .IB(D26_n_pin) , .O(IntDx26));
IBUFDS #(.DIFF_TERM("TRUE"),.IOSTANDARD("LVDS_25")) 	IBUFDS_inst27(.I(D27_p_pin) , .IB(D27_n_pin) , .O(IntDx27));
IBUFDS #(.DIFF_TERM("TRUE"),.IOSTANDARD("LVDS_25")) 	IBUFDS_inst28(.I(D28_p_pin) , .IB(D28_n_pin) , .O(IntDx28));
IBUFDS #(.DIFF_TERM("TRUE"),.IOSTANDARD("LVDS_25")) 	IBUFDS_inst29(.I(D29_p_pin) , .IB(D29_n_pin) , .O(IntDx29));
IBUFDS #(.DIFF_TERM("TRUE"),.IOSTANDARD("LVDS_25")) 	IBUFDS_inst30(.I(D30_p_pin), .IB(D30_n_pin), .O(IntDx30));
IBUFDS #(.DIFF_TERM("TRUE"),.IOSTANDARD("LVDS_25")) 	IBUFDS_inst31(.I(D31_p_pin), .IB(D31_n_pin), .O(IntDx31));
IBUFDS #(.DIFF_TERM("TRUE"),.IOSTANDARD("LVDS_25")) 	IBUFDS_inst32(.I(D32_p_pin), .IB(D32_n_pin), .O(IntDx32));
IBUFDS #(.DIFF_TERM("TRUE"),.IOSTANDARD("LVDS_25")) 	IBUFDS_inst33(.I(D33_p_pin), .IB(D33_n_pin), .O(IntDx33));
IBUFDS #(.DIFF_TERM("TRUE"),.IOSTANDARD("LVDS_25")) 	IBUFDS_inst34(.I(D34_p_pin), .IB(D34_n_pin), .O(IntDx34));

IBUF #(.IOSTANDARD("LVCMOS33")) AppsToplevel_I_IbufRst(.I(SysRst_pin), .O(IntSysRst));
IBUF #(.IOSTANDARD("LVCMOS33")) AppsToplevel_I_IbufEn(.I(ChanEn_pin), .O(IntChanEn));
IBUF #(.IOSTANDARD("LVCMOS33")) Ibuf_UART_Sin(.I(AppUART_Sin_pin), .O(IntAppUART_Sin));
IBUF #(.IOSTANDARD("LVCMOS33")) Ibuf_UART_RTSn(.I(AppUART_RTSn_pin), .O(IntAppUART_RTSn));
IBUF #(.IOSTANDARD("LVCMOS33")) Ibuf_UART_DTRn(.I(AppUART_DTRn_pin), .O(IntAppUART_DTRn));
IBUF #(.IOSTANDARD("LVCMOS33")) AppsToplevel_I_USBClk(.I(CLKOUT_pin), .O(tusb_bclk));
//
OBUF #(.SLEW("slow"),.IOSTANDARD("LVCMOS33"),.DRIVE(12)) Obuf_UART_Sout(.I(IntAppUART_Sout), .O(AppUART_Sout_pin));
OBUF #(.SLEW("slow"),.IOSTANDARD("LVCMOS33"),.DRIVE(12)) Obuf_UART_CTSn(.I(IntAppUART_CTSn), .O(AppUART_CTSn_pin));
OBUF #(.SLEW("slow"),.IOSTANDARD("LVCMOS33"),.DRIVE(12)) Obuf_UART_DSRn(.I(IntAppUART_DSRn), .O(AppUART_DSRn_pin));
OBUF #(.SLEW("slow"),.IOSTANDARD("LVCMOS33"),.DRIVE(12)) Obuf_UART_DCDn(.I(IntAppUART_DCDn), .O(AppUART_DCDn_pin));
OBUF #(.SLEW("slow"),.IOSTANDARD("LVCMOS33"),.DRIVE(12)) Obuf_UART_RIn(.I(IntAppUART_RIn), .O(AppUART_RIn_pin));
//
OBUF #(.SLEW("slow"),.IOSTANDARD("LVCMOS33"),.DRIVE(12)) Obuf_SPI_Ss(.I(IntAppSPI_Ss), .O(AppSPI_Ss_pin));
OBUF #(.SLEW("slow"),.IOSTANDARD("LVCMOS33"),.DRIVE(12)) Obuf_SPI_Mosi(.I(IntAppSPI_Mosi), .O(AppSPI_Mosi_pin));
OBUF #(.SLEW("slow"),.IOSTANDARD("LVCMOS33"),.DRIVE(12)) Obuf_SPI_Sclk(.I(IntAppSPI_Sclk), .O(AppSPI_Sclk_pin));
//
OBUFT #(.SLEW("fast"),.IOSTANDARD("LVCMOS33"),.DRIVE(12)) AppCh1Clk(.I(OO), .T(IntChanEn1), .O(AppDatClkCh1_pin));
OBUFT #(.SLEW("fast"),.IOSTANDARD("LVCMOS33"),.DRIVE(12)) AppTP6_0(.I(pIntDx_r[00]), .T(IntChanEn1), .O(AppTP0_pin[0]));
OBUFT #(.SLEW("fast"),.IOSTANDARD("LVCMOS33"),.DRIVE(12)) AppTP6_1(.I(pIntDx_r[01]), .T(IntChanEn1), .O(AppTP0_pin[1]));
OBUFT #(.SLEW("fast"),.IOSTANDARD("LVCMOS33"),.DRIVE(12)) AppTP6_2(.I(pIntDx_r[02]), .T(IntChanEn1), .O(AppTP0_pin[2]));
OBUFT #(.SLEW("fast"),.IOSTANDARD("LVCMOS33"),.DRIVE(12)) AppTP6_3(.I(pIntDx_r[03]), .T(IntChanEn1), .O(AppTP0_pin[3]));
OBUFT #(.SLEW("fast"),.IOSTANDARD("LVCMOS33"),.DRIVE(12)) AppTP6_4(.I(pIntDx_r[04]), .T(IntChanEn1), .O(AppTP0_pin[4]));
OBUFT #(.SLEW("fast"),.IOSTANDARD("LVCMOS33"),.DRIVE(12)) AppTP6_5(.I(pIntDx_r[05]), .T(IntChanEn1), .O(AppTP0_pin[5]));
OBUFT #(.SLEW("fast"),.IOSTANDARD("LVCMOS33"),.DRIVE(12)) AppTP6_6(.I(pIntDx_r[06]), .T(IntChanEn1), .O(AppTP0_pin[6]));
OBUFT #(.SLEW("fast"),.IOSTANDARD("LVCMOS33"),.DRIVE(12)) AppTP6_7(.I(pIntDx_r[07]), .T(IntChanEn1), .O(AppTP0_pin[7]));
OBUFT #(.SLEW("fast"),.IOSTANDARD("LVCMOS33"),.DRIVE(12)) AppTP7_0(.I(pIntDx_r[08]), .T(IntChanEn1), .O(AppTP0_pin[8]));
OBUFT #(.SLEW("fast"),.IOSTANDARD("LVCMOS33"),.DRIVE(12)) AppTP7_1(.I(pIntDx_r[09]), .T(IntChanEn1), .O(AppTP0_pin[9]));
OBUFT #(.SLEW("fast"),.IOSTANDARD("LVCMOS33"),.DRIVE(12)) AppTP7_2(.I(pIntDx_r[10]), .T(IntChanEn1), .O(AppTP0_pin[10]));
OBUFT #(.SLEW("fast"),.IOSTANDARD("LVCMOS33"),.DRIVE(12)) AppTP7_3(.I(pIntDx_r[11]), .T(IntChanEn1), .O(AppTP0_pin[11]));
OBUFT #(.SLEW("fast"),.IOSTANDARD("LVCMOS33"),.DRIVE(12)) AppTP7_4(.I(pIntDx_r[12]), .T(IntChanEn1), .O(AppTP0_pin[12]));
OBUFT #(.SLEW("fast"),.IOSTANDARD("LVCMOS33"),.DRIVE(12)) AppTP7_5(.I(pIntDx_r[13]), .T(IntChanEn1), .O(AppTP0_pin[13]));
//
OBUFT #(.SLEW("fast"),.IOSTANDARD("LVCMOS33"),.DRIVE(12)) AppCh2Clk(.I(OO), .T(IntChanEn2), .O(AppDatClkCh2_pin));
OBUFT #(.SLEW("fast"),.IOSTANDARD("LVCMOS33"),.DRIVE(12)) AppTP4_0(.I(nIntDx_r[00]), .T(IntChanEn2), .O(AppTP1_pin[0]));
OBUFT #(.SLEW("fast"),.IOSTANDARD("LVCMOS33"),.DRIVE(12)) AppTP4_1(.I(nIntDx_r[01]), .T(IntChanEn2), .O(AppTP1_pin[1]));
OBUFT #(.SLEW("fast"),.IOSTANDARD("LVCMOS33"),.DRIVE(12)) AppTP4_2(.I(nIntDx_r[02]), .T(IntChanEn2), .O(AppTP1_pin[2]));
OBUFT #(.SLEW("fast"),.IOSTANDARD("LVCMOS33"),.DRIVE(12)) AppTP4_3(.I(nIntDx_r[03]), .T(IntChanEn2), .O(AppTP1_pin[3]));
OBUFT #(.SLEW("fast"),.IOSTANDARD("LVCMOS33"),.DRIVE(12)) AppTP4_4(.I(nIntDx_r[04]), .T(IntChanEn2), .O(AppTP1_pin[4]));
OBUFT #(.SLEW("fast"),.IOSTANDARD("LVCMOS33"),.DRIVE(12)) AppTP4_5(.I(nIntDx_r[05]), .T(IntChanEn2), .O(AppTP1_pin[5]));
OBUFT #(.SLEW("fast"),.IOSTANDARD("LVCMOS33"),.DRIVE(12)) AppTP4_6(.I(nIntDx_r[06]), .T(IntChanEn2), .O(AppTP1_pin[6]));
OBUFT #(.SLEW("fast"),.IOSTANDARD("LVCMOS33"),.DRIVE(12)) AppTP4_7(.I(nIntDx_r[07]), .T(IntChanEn2), .O(AppTP1_pin[7]));
OBUFT #(.SLEW("fast"),.IOSTANDARD("LVCMOS33"),.DRIVE(12)) AppTP5_0(.I(nIntDx_r[08]), .T(IntChanEn2), .O(AppTP1_pin[8]));
OBUFT #(.SLEW("fast"),.IOSTANDARD("LVCMOS33"),.DRIVE(12)) AppTP5_1(.I(nIntDx_r[09]), .T(IntChanEn2), .O(AppTP1_pin[9]));
OBUFT #(.SLEW("fast"),.IOSTANDARD("LVCMOS33"),.DRIVE(12)) AppTP5_2(.I(nIntDx_r[10]), .T(IntChanEn2), .O(AppTP1_pin[10]));
OBUFT #(.SLEW("fast"),.IOSTANDARD("LVCMOS33"),.DRIVE(12)) AppTP5_3(.I(nIntDx_r[11]), .T(IntChanEn2), .O(AppTP1_pin[11]));
OBUFT #(.SLEW("fast"),.IOSTANDARD("LVCMOS33"),.DRIVE(12)) AppTP5_4(.I(nIntDx_r[12]), .T(IntChanEn2), .O(AppTP1_pin[12]));
OBUFT #(.SLEW("fast"),.IOSTANDARD("LVCMOS33"),.DRIVE(12)) AppTP5_5(.I(nIntDx_r[13]), .T(IntChanEn2), .O(AppTP1_pin[13]));
OBUFT #(.SLEW("fast"),.IOSTANDARD("LVCMOS33"),.DRIVE(12)) AppTP5_6(.I(nIntDx_r[14]), .T(IntChanEn2), .O(AppTP1_pin[14]));
OBUFT #(.SLEW("fast"),.IOSTANDARD("LVCMOS33"),.DRIVE(12)) AppTP5_7(.I(nIntDx_r[15]), .T(IntChanEn2), .O(AppTP1_pin[15]));
//
OBUFT #(.SLEW("fast"),.IOSTANDARD("LVCMOS33"),.DRIVE(12)) AppCh3Clk(.I(OO), .T(IntChanEn3), .O(AppDatClkCh3_pin));
OBUFT #(.SLEW("fast"),.IOSTANDARD("LVCMOS33"),.DRIVE(12)) AppTP2_0(.I(pIntDx90_r[00]), .T(IntChanEn3), .O(AppTP2_pin[0]));
OBUFT #(.SLEW("fast"),.IOSTANDARD("LVCMOS33"),.DRIVE(12)) AppTP2_1(.I(pIntDx90_r[01]), .T(IntChanEn3), .O(AppTP2_pin[1]));
OBUFT #(.SLEW("fast"),.IOSTANDARD("LVCMOS33"),.DRIVE(12)) AppTP2_2(.I(pIntDx90_r[02]), .T(IntChanEn3), .O(AppTP2_pin[2]));
OBUFT #(.SLEW("fast"),.IOSTANDARD("LVCMOS33"),.DRIVE(12)) AppTP2_3(.I(pIntDx90_r[03]), .T(IntChanEn3), .O(AppTP2_pin[3]));
OBUFT #(.SLEW("fast"),.IOSTANDARD("LVCMOS33"),.DRIVE(12)) AppTP2_4(.I(pIntDx90_r[04]), .T(IntChanEn3), .O(AppTP2_pin[4]));
OBUFT #(.SLEW("fast"),.IOSTANDARD("LVCMOS33"),.DRIVE(12)) AppTP2_5(.I(pIntDx90_r[05]), .T(IntChanEn3), .O(AppTP2_pin[5]));
OBUFT #(.SLEW("fast"),.IOSTANDARD("LVCMOS33"),.DRIVE(12)) AppTP2_6(.I(pIntDx90_r[06]), .T(IntChanEn3), .O(AppTP2_pin[6]));
OBUFT #(.SLEW("fast"),.IOSTANDARD("LVCMOS33"),.DRIVE(12)) AppTP2_7(.I(pIntDx90_r[07]), .T(IntChanEn3), .O(AppTP2_pin[7]));
OBUFT #(.SLEW("fast"),.IOSTANDARD("LVCMOS33"),.DRIVE(12)) AppTP3_0(.I(pIntDx90_r[08]), .T(IntChanEn3), .O(AppTP2_pin[8]));
OBUFT #(.SLEW("fast"),.IOSTANDARD("LVCMOS33"),.DRIVE(12)) AppTP3_1(.I(pIntDx90_r[09]), .T(IntChanEn3), .O(AppTP2_pin[9]));
OBUFT #(.SLEW("fast"),.IOSTANDARD("LVCMOS33"),.DRIVE(12)) AppTP3_2(.I(pIntDx90_r[10]), .T(IntChanEn3), .O(AppTP2_pin[10]));
OBUFT #(.SLEW("fast"),.IOSTANDARD("LVCMOS33"),.DRIVE(12)) AppTP3_3(.I(pIntDx90_r[11]), .T(IntChanEn3), .O(AppTP2_pin[11]));
OBUFT #(.SLEW("fast"),.IOSTANDARD("LVCMOS33"),.DRIVE(12)) AppTP3_4(.I(pIntDx90_r[12]), .T(IntChanEn3), .O(AppTP2_pin[12]));
OBUFT #(.SLEW("fast"),.IOSTANDARD("LVCMOS33"),.DRIVE(12)) AppTP3_5(.I(pIntDx90_r[13]), .T(IntChanEn3), .O(AppTP2_pin[13]));
OBUFT #(.SLEW("fast"),.IOSTANDARD("LVCMOS33"),.DRIVE(12)) AppTP3_6(.I(pIntDx90_r[14]), .T(IntChanEn3), .O(AppTP2_pin[14]));
OBUFT #(.SLEW("fast"),.IOSTANDARD("LVCMOS33"),.DRIVE(12)) AppTP3_7(.I(pIntDx90_r[15]), .T(IntChanEn3), .O(AppTP2_pin[15]));
//
OBUFT #(.SLEW("fast"),.IOSTANDARD("LVCMOS33"),.DRIVE(12)) AppCh4Clk(.I(OO), .T(IntChanEn4), .O(AppDatClkCh4_pin));
OBUFT #(.SLEW("fast"),.IOSTANDARD("LVCMOS33"),.DRIVE(12)) AppTP0_0(.I(nIntDx90_r[00]), .T(IntChanEn4), .O(AppTP3_pin[0]));
OBUFT #(.SLEW("fast"),.IOSTANDARD("LVCMOS33"),.DRIVE(12)) AppTP0_1(.I(nIntDx90_r[01]), .T(IntChanEn4), .O(AppTP3_pin[1]));
OBUFT #(.SLEW("fast"),.IOSTANDARD("LVCMOS33"),.DRIVE(12)) AppTP0_2(.I(nIntDx90_r[02]), .T(IntChanEn4), .O(AppTP3_pin[2]));
OBUFT #(.SLEW("fast"),.IOSTANDARD("LVCMOS33"),.DRIVE(12)) AppTP0_3(.I(nIntDx90_r[03]), .T(IntChanEn4), .O(AppTP3_pin[3]));
OBUFT #(.SLEW("fast"),.IOSTANDARD("LVCMOS33"),.DRIVE(12)) AppTP0_4(.I(nIntDx90_r[04]), .T(IntChanEn4), .O(AppTP3_pin[4]));
OBUFT #(.SLEW("fast"),.IOSTANDARD("LVCMOS33"),.DRIVE(12)) AppTP0_5(.I(nIntDx90_r[05]), .T(IntChanEn4), .O(AppTP3_pin[5]));
OBUFT #(.SLEW("fast"),.IOSTANDARD("LVCMOS33"),.DRIVE(12)) AppTP0_6(.I(nIntDx90_r[06]), .T(IntChanEn4), .O(AppTP3_pin[6]));
OBUFT #(.SLEW("fast"),.IOSTANDARD("LVCMOS33"),.DRIVE(12)) AppTP0_7(.I(nIntDx90_r[07]), .T(IntChanEn4), .O(AppTP3_pin[7]));
OBUFT #(.SLEW("fast"),.IOSTANDARD("LVCMOS33"),.DRIVE(12)) AppTP1_0(.I(nIntDx90_r[08]), .T(IntChanEn4), .O(AppTP3_pin[8]));
OBUFT #(.SLEW("fast"),.IOSTANDARD("LVCMOS33"),.DRIVE(12)) AppTP1_1(.I(nIntDx90_r[09]), .T(IntChanEn4), .O(AppTP3_pin[9]));
OBUFT #(.SLEW("fast"),.IOSTANDARD("LVCMOS33"),.DRIVE(12)) AppTP1_2(.I(nIntDx90_r[10]), .T(IntChanEn4), .O(AppTP3_pin[10]));
OBUFT #(.SLEW("fast"),.IOSTANDARD("LVCMOS33"),.DRIVE(12)) AppTP1_3(.I(nIntDx90_r[11]), .T(IntChanEn4), .O(AppTP3_pin[11]));
OBUFT #(.SLEW("fast"),.IOSTANDARD("LVCMOS33"),.DRIVE(12)) AppTP1_4(.I(nIntDx90_r[12]), .T(IntChanEn4), .O(AppTP3_pin[12]));
OBUFT #(.SLEW("fast"),.IOSTANDARD("LVCMOS33"),.DRIVE(12)) AppTP1_5(.I(nIntDx90_r[13]), .T(IntChanEn4), .O(AppTP3_pin[13]));

OBUF #(.SLEW("slow"),.IOSTANDARD("LVCMOS33"),.DRIVE(12)) AppAppLed_0(.I(AdcLife), .O(AppLed_pin[2]));
OBUF #(.SLEW("slow"),.IOSTANDARD("LVCMOS33"),.DRIVE(12)) AppAppLed_1(.I(usb_busy_b), .O(AppLed_pin[1]));
OBUF #(.SLEW("slow"),.IOSTANDARD("LVCMOS33"),.DRIVE(12)) AppAppLed_2(.I(SysRst), .O(AppLed_pin[0]));
OBUF #(.SLEW("slow"),.IOSTANDARD("LVCMOS33"),.DRIVE(12)) AppAppLed_3(.I(SysLife), .O(AppLed_pin[3]));
//------------------------------------------------------------------------------

assign IntDx = {IntDx14,IntDx13,IntDx12,IntDx11,IntDx10,IntDx09,IntDx08,IntDx07,IntDx06,IntDx05,IntDx04,IntDx03,IntDx02,IntDx01,IntDx00};
assign IntDx2 = {IntDx34,IntDx33,IntDx32,IntDx31,IntDx30,IntDx29,IntDx28,IntDx27,IntDx26,IntDx25,IntDx24,IntDx23,IntDx22,IntDx21,IntDx20};

//------------------------------------------------------------------------------

IBUFDS #(.DIFF_TERM("TRUE"),.IOSTANDARD("LVDS_25")) 	IBUFDS_instDDRClk(.I(DDRClk_p_pin),.IB(DDRClk_n_pin),.O(CLKIN_DDR));
IBUFGDS #(.DIFF_TERM("TRUE"),.IOSTANDARD("LVDS_25")) 	IBUFDS_instSysClk(.I(SysClk_p_pin),.IB(SysClk_n_pin),.O(CLKIN_OSC));

wire	CLKDLY_DDR;
ads5463_ddrif ads5463_ddrif_inst
       (
			.cntrl0_DDR2_DQ		(IntDx),
			.cntrl1_DDR2_DQ		(IntDx2),
			.REF_CLK200_IN		(CLKIN_OSC),
			.SYS_RESET_IN_N		(IntSysRst),
			.cntrl0_DDR2_DQS	(CLKIN_DDR),
			.dlyen				(dlyen),
			.dlyinc				(dlyinc),
			.dlyrst				(dlyrst),
			.dlyinc_val			(dlyinc_val),
			.dlydbit_sel		(dlydbit_sel[`data_width-1:0]),
			.dlyclk_sel			(dlyclk_sel),
			.capture_modes		(cap_modes),
			.channel_sel		(chan_sel),

			.CLK				(IntSysClk),
			.CLK90				(),
			.CLKDIV_0			(IntSysClkDiv),
			.CLKDIV_90			(),
			.RESET0				(SysRst),
			.RESET90				(),
			.RESET270			(),

			.dqs_div			(CLKDLY_DDR),
			.cntrl0_READ_DATA0	(pIntDx_r),
			.cntrl0_READ_DATA1	(nIntDx_r),
			.cntrl0_READ_DATA2	(pIntDx90_r),
			.cntrl0_READ_DATA3	(nIntDx90_r)
        );

assign	ch1_clk = CLKDLY_DDR;
assign	ch2_clk = CLKDLY_DDR;
assign	ch3_clk = CLKDLY_DDR;
assign	ch4_clk = CLKDLY_DDR;

evbif evbif_inst(
			.sys_clk	(IntSysClk),
			.sys_clk_div	(IntSysClkDiv),
			.reset		(SysRst),
			.ext_trig	(IntSysRst),		// hf@091009
			.tusb_bclk	(tusb_bclk),
			.sin		(IntAppUART_Sin),
			.rts_n		(rts_n),
			.dtr_n		(dtr_n),
			.ch1_clk	(ch1_clk),
			.ch2_clk	(ch2_clk),
			.ch3_clk	(ch3_clk),
			.ch4_clk	(ch4_clk),
			.ch1_din	(pIntDx_r),
			.ch2_din	(nIntDx_r),
			.ch3_din	(pIntDx90_r),
			.ch4_din	(nIntDx90_r),
// synthesis translate_off
			.full4		(),
			.full3		(),
			.full2		(),
			.full1		(),
			.empty		(),
			.fifo1_we	(),
			.fifo2_we	(),
			.fifo3_we	(),
			.fifo4_we	(),
			.fifo1_din	(),
			.fifo2_din	(),
			.fifo3_din	(),
			.fifo4_din	(),
// synthesis translate_on
			.dlyen		(dlyen),
			.dlyinc		(dlyinc),
			.dlyrst		(dlyrst),
			.dlyinc_val	(dlyinc_val),
			.dlydbit_sel(dlydbit_sel),
			.dlyclk_sel	(dlyclk_sel),
			.spi_ss		(IntAppSPI_Ss),
			.spi_sclk	(IntAppSPI_Sclk),
			.spi_mosi	(IntAppSPI_Mosi),
			.spi_miso	(1'b0),
			.cts_n		(IntAppUART_CTSn),
			.dsr_n		(IntAppUART_DSRn),
			.dcd_n		(IntAppUART_DCDn),
			.ri_n		(IntAppUART_RIn),
			.sout		(IntAppUART_Sout),
			.ibz		(usb_busy),
			.capture_modes (cap_modes),
			.channel_sel (chan_sel)
			);

assign 	usb_busy_b = ~usb_busy;

Life_Pulse life_pulse_sys_inst(
			.clkin		(IntSysClk),
			.enable 		(SysRst),
			.life_out	(SysLife)
			);


Life_Pulse life_pulse_adc_inst(
			.clkin		(CLKDLY_DDR),
			.enable 		(SysRst),
			.life_out	(AdcLife)
			);

//-----------------------------------------------------------------------------

always @ (IntChanEn or chan_sel)
	begin
		IntChanEn1 <= ~(IntChanEn & chan_sel[0]);
		IntChanEn2 <= ~(IntChanEn & chan_sel[1]);
		IntChanEn3 <= ~(IntChanEn & chan_sel[2]);
		IntChanEn4 <= ~(IntChanEn & chan_sel[3]);
	end

always @(posedge IntSysClk)
begin
	rts_n		<=`DLY IntAppUART_RTSn;
	dtr_n		<=`DLY IntAppUART_DTRn;
end

//-----------------------------------------------------------------------------

assign	C = CLKDLY_DDR ? 1'b0 : 1'b1;
BUFG	BUFG_inst(.I	(C), .O	(OO));
//ODDR ODDR_inst (
//      .Q(),   // 1-bit DDR output
//      .C(1'b0),   // 1-bit clock input
//      .CE(1'b1), // 1-bit clock enable input
//      .D1(1'b0), // 1-bit data input (positive edge)
//      .D2(1'b1), // 1-bit data input (negative edge)
//      .R(1'b0),   // 1-bit reset
//      .S(1'b0)    // 1-bit set
//      );

   // The following defparams specify the behavior of the ODDR
   // component.  If the instance name is changed, that
   // change needs to be reflected in the defparam statements.

//   defparam ODDR_inst.DDR_CLK_EDGE = "OPPOSITE_EDGE"; // "OPPOSITE_EDGE" or "SAME_EDGE"
//   defparam ODDR_inst.INIT = 1'b0; // Initial value of Q: 1'b0 or 1'b1
//   defparam ODDR_inst.SRTYPE = "SYNC"; // Set/Reset type: "SYNC" or "ASYNC"

//-----------------------------------------------------------------------------

endmodule
